/***************************************************************************
                          c_aacodesiomanip.cpp  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_aacodesiomanip.h"

/***************************************************************************
 *                                                                         *
 *   operator >>
 *                                                                         *
 ***************************************************************************/

C_XMLTag &
C_AACodesIOManip::
operator >> (S_AACodes & AACodes) const
{
    is () >> ws;
    if (is ().name != "aa-codes")
        is ().setstate (ios::failbit);
    else
        while (is ().good ())
        {
            C_XMLTag ParamTag;
            is () >> ParamTag >> ws;
            ParamTag >> ws;

            if (ParamTag.name != "aa-code")
                is ().setstate (ios::failbit);
            else
            {
                string Buffer_str;
                ParamTag.getAttributeStream ("name") >> Buffer_str;
                if (ParamTag.attributeStream ().fail ())
                    ParamTag.setstate (ios::failbit);
                else if (Buffer_str == aa1l.aaCodeStr ())
                    readAACodes (ParamTag, AACodes.m_Known1lCodes_map);
                else if (Buffer_str == aa3l.aaCodeStr ())
                    readAACodes (ParamTag, AACodes.m_Known3lCodes_map);
                else if (Buffer_str == aastr.aaCodeStr ())
                    readAACodes (ParamTag, AACodes.m_KnownStrCodes_map);
                else
                    ParamTag.setstate (ios::failbit);

                if (ParamTag.fail ())
                    is ().setstate (ios::failbit);
            }
        }
    return is ();
};


/***************************************************************************
 *                                                                         *
 *   operator <<
 *                                                                         *
 ***************************************************************************/

ostream &
C_AACodesIOManip::
operator << (const S_AACodes & AACodes) const
{
    multimap <E_AminoAcid, char> AA1lCodes_map;
    for (S_AACodes::known_1l_codes_t::const_iterator i = AACodes.m_Known1lCodes_map.begin ();
            i != AACodes.m_Known1lCodes_map.end (); i ++)
        AA1lCodes_map.insert (make_pair (i->second, i->first));

    multimap <E_AminoAcid, string> AA3lCodes_map;
    for (S_AACodes::known_3l_codes_t::const_iterator i = AACodes.m_Known3lCodes_map.begin ();
            i != AACodes.m_Known3lCodes_map.end (); i ++)
        AA3lCodes_map.insert (make_pair (i->second, i->first));

    multimap <E_AminoAcid, string> AAStrCodes_map;
    for (S_AACodes::known_str_codes_t::const_iterator i = AACodes.m_KnownStrCodes_map.begin ();
            i != AACodes.m_KnownStrCodes_map.end (); i ++)
        AAStrCodes_map.insert (make_pair (i->second, i->first));

    os () << xml_begt ("aa-codes") << endl
    << xml_begt ("aa-code", xml_withat) << xml_at ("name", aa1l.aaCodeStr ()) << xml_endats << endl;

    writeAACodes (AA1lCodes_map);

    os () << xml_endt ("aa-code") << endl
    << xml_begt ("aa-code", xml_withat) << xml_at ("name", aa3l.aaCodeStr ()) << xml_endats << endl;

    writeAACodes (AA3lCodes_map);

    os () << xml_endt ("aa-code") << endl
    << xml_begt ("aa-code", xml_withat) << xml_at ("name", aastr.aaCodeStr ()) << xml_endats << endl;

    writeAACodes (AAStrCodes_map);

    return os () << xml_endt ("aa-code") << endl << xml_endt ("aa-codes") << endl;
};
