/***************************************************************************
                          c_aapropertiesiomanip.cpp  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_aapropertiesiomanip.h"


C_XMLTag &
C_AAPropertiesIOManip::
operator >> (S_AAProperties & Properties) const
{
    is () >> ws;
    if (is ().name != "aa-properties")
        is ().setstate (ios::failbit);
    else
        while (is ().good ())
        {
            C_XMLTag ParamTag;
            is () >> ParamTag >> ws;
            ParamTag >> ws;
            if (ParamTag.name == "hydrophobic-aas")
                readPropertyAAs (ParamTag, Properties.hydrophobicAAs ());
            else if (ParamTag.name == "cluster-breaker-aas")
                readPropertyAAs (ParamTag, Properties.clusterBreakerAAs ());
            else if (ParamTag.name == "non-aas")
                readPropertyAAs (ParamTag, Properties.nonAAs ());
            else
                is ().setstate (ios::failbit);

            if (ParamTag.fail ())
                is ().setstate (ios::failbit);
        }
    return is ();
};


ostream &
C_AAPropertiesIOManip::
operator << (const S_AAProperties & Properties) const
{
    os () << xml_begt ("aa-properties") << endl

    << xml_begt ("hydrophobic-aas") << endl;
    writePropertyAAs (Properties.hydrophobicAAs ());
    os () << xml_endt ("hydrophobic-aas") << endl

    << xml_begt ("cluster-breaker-aas") << endl;
    writePropertyAAs (Properties.clusterBreakerAAs ());
    os () << xml_endt ("cluster-breaker-aas") << endl

    << xml_begt ("non-aas") << endl;
    writePropertyAAs (Properties.nonAAs ());
    os () << xml_endt ("non-aas") << endl

    << xml_endt ("aa-properties") << endl;
    return os ();
};
