/***************************************************************************
                          c_aapropertiesiomanip.h  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_AAPROPERTIESIOMANIP_H
#define C_AAPROPERTIESIOMANIP_H

#include "iomanip_aa.h"

using namespace N_AminoAcid;

/**
  *@author Cyril Deremble
  */

class C_AAPropertiesIOManip : public C_IOStreamManip <C_XMLTag, ostream>
{
public:

    C_XMLTag & operator >> (S_AAProperties & Properties) const;

    ostream & operator << (const S_AAProperties & Properties) const;

private:
    template <class T>
    void readPropertyAAs (C_XMLTag & Tag, T & PropertyAAs) const
    {
        E_AminoAcid AA;
        PropertyAAs.clear ();
        while (Tag.good ())
        {
            Tag >> xml_iaa >> AA >> ws;
            if (! Tag.fail ())
                PropertyAAs.insert (AA);
        }
    };

    template <class T>
    void writePropertyAAs (const T & PropertyAAs) const
    {
        typedef typename T::const_iterator iterator;
        for (iterator i = PropertyAAs.begin (); i != PropertyAAs.end (); i ++)
            os () << xml_oaa1l << *i << endl;
    };
};

const C_AAPropertiesIOManip xml_aapropparams = C_AAPropertiesIOManip ();

inline const C_AAPropertiesIOManip & operator >> (C_XMLTag & Stream, const C_AAPropertiesIOManip & Manip)
{
    Manip.setIStream (Stream);
    return Manip;
};

inline const C_AAPropertiesIOManip & operator << (ostream & Stream, const C_AAPropertiesIOManip & Manip)
{
    Manip.setOStream (Stream);
    return Manip;
};

#endif
