/***************************************************************************
                          c_alignparametersiomanip.cpp  -  description
                             -------------------
    begin                : Thu Jul 31 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_alignparametersiomanip.h"

/***************************************************************************
 *                                                                         *
 *   operator >>
 *                                                                         *
 ***************************************************************************/

C_XMLTag &
C_AlignParametersIOManip::
operator >> (C_ClustAlign & ClustAlign) const
{
    is () >> ws;
    if (is ().name != "align-parameters")
        is ().setstate (ios::failbit);
    else
        while (is ().good ())
        {
            C_XMLTag ParamTag;
            is () >> ParamTag >> ws;
            ParamTag >> ws;

            if (ParamTag.name == "gop")
                ParamTag >> ClustAlign.m_GOP;
            else if (ParamTag.name == "gep")
                ParamTag >> ClustAlign.m_GEP;
            else if (ParamTag.name == "end-gop")
                ParamTag >> ClustAlign.m_EndGOP;
            else if (ParamTag.name == "end-gep")
                ParamTag >> ClustAlign.m_EndGEP;
            else if (ParamTag.name == "cluster-gop")
                ParamTag >> ClustAlign.m_ClustGOP;
            else if (ParamTag.name == "cluster-gep")
                ParamTag >> ClustAlign.m_ClustGEP;
            else if (ParamTag.name == "score-matrix")
            {
                bool IsInCLuster_b = false;
                ParamTag.getAttributeStream ("in-cluster") >> boolalpha >> IsInCLuster_b;
                if (IsInCLuster_b)
                    ParamTag >> xml_iaasubsmatrix >> ClustAlign.m_ClusterSubsMat;
                else
                    ParamTag >> xml_iaasubsmatrix >> ClustAlign.m_SubsMat;
            }
            else
                is ().setstate (ios::failbit);

            if (ParamTag.fail ())
                is ().setstate (ios::failbit);
        }
    return is ();
};


/***************************************************************************
 *                                                                         *
 *   operator <<
 *                                                                         *
 ***************************************************************************/

ostream &
C_AlignParametersIOManip::
operator << (const C_ClustAlign & ClustAlign) const
{
    return os () << xml_begt ("align-parameters") << endl
           << xml_begt ("gop") << ClustAlign.m_GOP << xml_endt ("gop") << endl
           << xml_begt ("gep") << ClustAlign.m_GEP << xml_endt ("gep") << endl
           << xml_begt ("end-gop") << ClustAlign.m_EndGOP << xml_endt ("end-gop") << endl
           << xml_begt ("end-gep") << ClustAlign.m_EndGEP << xml_endt ("end-gep") << endl
           << xml_begt ("cluster-gop") << ClustAlign.m_ClustGOP << xml_endt ("cluster-gop") << endl
           << xml_begt ("cluster-gep") << ClustAlign.m_ClustGEP << xml_endt ("cluster-gep") << endl
           << xml_oaasubsmatrix << ClustAlign.m_SubsMat << endl
           << xml_oaasubsmatrix (true) << ClustAlign.m_ClusterSubsMat << endl
           << xml_endt ("align-parameters") << endl;
};
