/***************************************************************************
                          c_analysedseqs.h  -  description
                             -------------------
    begin                : Thu Jul 24 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_ANALYSEDSEQS_H
#define C_ANALYSEDSEQS_H

#include <list>
#include "c_analysedseq.h"
#include "c_alignedseqsgroup.h"
#include "c_clustalign.h"
#include "c_treenode.h"

/**
  *@author Cyril Deremble
  */

typedef double align_score_t;

class C_AnalysedSeqs : public list <C_AnalysedSeq>
{
	public:
		typedef list <C_AnalysedSeq> base_class_type;
		typedef base_class_type::value_type value_type;
		
		C_AnalysedSeqs () : m_AreAligned_b (false), m_AlignmentScore (0)
		{}
		
		
		reference operator [] (const string & Name)
		{
			for (iterator i = begin (); i != end (); i ++)
			{
				if (i->name () == Name)
				{
					return *i;
				}
			}
			return *end ();
		}

		const_reference operator [] (const string & Name) const
		{
			for (const_iterator i = begin (); i != end (); i ++)
			{
				if (i->name () == Name)
				{
					return *i;
				}
			}
			return *end ();
		}

		C_AnalysedSeqs* clone (){
		  return new C_AnalysedSeqs(*this);
		}

		align_score_t align ();
		align_score_t align (const C_TreeNode <string> & Tree);
		//align_score_t alignIter (const C_TreeNode <string> & Tree);

		bool & areAligned ()
		{
			return m_AreAligned_b;
		}
		bool areAligned () const
		{
			return m_AreAligned_b;
		}
		
		align_score_t & alignScore () {return m_AlignmentScore;}
		align_score_t alignScore () const {return m_AlignmentScore;}
		
		size_t sequencesSize () const {return empty () ? 0 : front ().size ();}
		
	private:
		bool m_AreAligned_b;
		align_score_t m_AlignmentScore;
		
		align_score_t alignNode (const C_TreeNode <string> & Node);
		//align_score_t alignNodeIter (const C_TreeNode <string> & Node);
};

#endif
