/***************************************************************************
                          c_clustalign.cpp  -  description
                             -------------------
    begin                : Thu Jun 12 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "c_clustalign.h"
#include "subsmats.h"

C_ClustAlign clustAlign = C_ClustAlign ();

/***************************************************************************
*                                                                         *
*   C_ClustAlign
*                                                                         *
***************************************************************************/

C_ClustAlign::C_ClustAlign ()
    :   m_SubsMat (g_ohbm_p),
	m_ClusterSubsMat (g_ihbm_p),
	m_GOP (10),
	m_GEP (1),
	m_EndGOP (2),
	m_EndGEP (1),
	m_ClustGOP (15),
	m_ClustGEP (2),
	m_Overlap (true)
{}


/**************************************************************************
*                                                                         *
*   initScoreMat                                                          *
*                                                                         *
***************************************************************************/

void C_ClustAlign::initScoreMat (size_t Size1, size_t Size2) const
{
	m_Score_mat.resize (Size1, Size2);
	
	mat_iterator Score_it;
	score_t Score;
	
	m_Score_mat.begin ()->Score = 0;
	m_Score_mat.begin ()->PrevCellPos = NO_DIR;
	
	// init the first row
	for (Score = - m_EndGOP,
	     Score_it = m_Score_mat.beginMat ().colIncr ();
	     Score_it != m_Score_mat.end ();
	     Score_it.colIncr (), Score -= m_EndGEP)
	{
	  Score_it->Score = Score;
	  Score_it->PrevCellPos = LEFT_DIR;
	}
	
	// init the first column
	for (Score = - m_EndGOP,
	     Score_it = m_Score_mat.beginMat ().rowIncr ();
	     Score_it != m_Score_mat.end ();
	     Score_it.rowIncr (), Score -= m_EndGEP)
	{
	  Score_it->Score = Score;
	  Score_it->PrevCellPos = UP_DIR;
	}
}

