/***************************************************************************
                          c_clusteredaaiterator.h  -  description
                             -------------------
    begin                : Tue May 6 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_CLUSTEREDAAITERATOR_H
#define C_CLUSTEREDAAITERATOR_H

/**
  *@author Cyril Deremble
  */


/***************************************************************************
 *                                                                         *
 *   Include files                                                         *
 *                                                                         *
 ***************************************************************************/

#include "n_aminoacid.h"
#include "c_iterator.h"


using namespace N_Tools;
using namespace N_AminoAcid;

/***************************************************************************
 *                                                                         *
 *   C_ClusteredAAIterator                                                 *
 *                                                                         *
 ***************************************************************************/

template <class value_t, class iterator_t>
class C_ClusteredAAIterator : public C_TestIterator <S_IsAA, value_t, iterator_t>
{
public:
    typedef C_TestIterator <S_IsAA, value_t, iterator_t> base_class_t;
    typedef value_t value_type;
    typedef iterator_t iterator;

    C_ClusteredAAIterator ()
    {}
    ;
    C_ClusteredAAIterator (iterator it,
                           iterator Begin_it,
                           iterator End_it)
            : base_class_t (it, Begin_it, End_it)
    {}
    ;

    template <class T, class U>
    C_ClusteredAAIterator (C_ClusteredAAIterator <T, U> it)
            : base_class_t (it)
    {}
    ;

    template <class T, class U, class V>
    C_ClusteredAAIterator (C_TestIterator <T, U, V> it)
            : base_class_t (it)
    {}
    ;

    C_ClusteredAAIterator & operator ++ ()
    {
        (base_class_t::m_it->Next == CLUSTER_END) ? (*this) += END_INCR : (*this) += base_class_t::m_it->Next;
        return *this;
    };
    C_ClusteredAAIterator operator ++ (int)
    {
        C_ClusteredAAIterator it (*this);
        (base_class_t::m_it->Next == CLUSTER_END) ? (*this) += END_INCR : (*this) += base_class_t::m_it->Next;
        return it;
    };

    C_ClusteredAAIterator & operator -- ()
    {
        (base_class_t::m_it->Prev == CLUSTER_END) ? (*this) -= END_INCR : (*this) -= base_class_t::m_it->Prev;
        return *this;
    };
    C_ClusteredAAIterator operator -- (int)
    {
        C_ClusteredAAIterator it (*this);
        (base_class_t::m_it->Prev == CLUSTER_END) ? (*this) -= END_INCR : (*this) -= base_class_t::m_it->Prev;
        return it;
    };

private:
    using base_class_t::operator ++;
    using base_class_t::operator +=;
    using base_class_t::operator -=;
    using base_class_t::operator --;
};


#endif
