/***************************************************************************
                          c_clusteriterator.h  -  description
                             -------------------
    begin                : Tue May 6 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_CLUSTERITERATOR_H
#define C_CLUSTERITERATOR_H

#include "c_testiterator.h"
#include "c_cluster.h"


/***************************************************************************
 *                                                                         *
 *   C_ClusterIterator                                                     *
 *                                                                         *
 ***************************************************************************/

/**
  *@author Cyril Deremble
  */

template <class value_t, class iterator_t>
class C_ClusterIterator : public C_TestIterator <S_IsFirstInCluster,
            C_Cluster <value_t, iterator_t>, iterator_t>
{
public:
    typedef iterator_t iterator;
    typedef C_Cluster <value_t, iterator> cluster_t;
    typedef S_IsFirstInCluster clusterTest_t;
    typedef C_TestIterator <clusterTest_t, cluster_t, iterator_t> base_class_t;

    C_ClusterIterator ()
    {}
    ;
    C_ClusterIterator (iterator it, iterator Begin_it, iterator End_it)
            :   base_class_t (it, Begin_it, End_it)
    {}
    ;

    template <class T,class U, class V>
    explicit C_ClusterIterator (const C_TestIterator <T, U, V> & it)
            :   base_class_t (it)
    {}
    ;

    cluster_t operator * () const
    {
        return cluster_t (*this);
    };

private:
    using base_class_t::operator *;
    using base_class_t::operator ->;
};


#endif
