/***************************************************************************
                          c_exception.h  -  description
                             -------------------
    begin                : Thu Apr 17 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_EXCEPTION_H
#define C_EXCEPTION_H

/**
  *@author Cyril Deremble
  */


/***************************************************************************
 *                                                                         *
 *   Include files                                                         *
 *                                                                         *
 ***************************************************************************/

#include <exception>
#include <string>
#include <sstream>
using namespace std;


/***************************************************************************
 *                                                                         *
 *   Class declaration                                                     *
 *                                                                         *
 ***************************************************************************/

class C_Exception : public exception, public string
{
public:
    explicit C_Exception ()
    {}
    ;

    C_Exception (const string & str)
            : string (str)
    {}
    ;
    C_Exception (const string & str, size_t pos, size_t n = npos)
            : string (str, pos, n)
    {}
    ;
    C_Exception (const char* s, size_t n)
            : string (s, n)
    {}
    ;
    C_Exception (const char* s)
            : string (s)
    {}
    ;
    C_Exception (size_t n, char c)
            : string (n, c)
    {}
    ;
    C_Exception (const_iterator begin, const_iterator end)
            : string (begin, end)
    {}
    ;

    ~C_Exception () throw ();

    const char * what () const throw ();

    template <class T>
    C_Exception & operator << (const T & t)
    {
        ostringstream t_str;
        t_str  << (t);
        (*this) += t_str.str ();
        return (*this);
    };
};


#endif
