/***************************************************************************
                          c_fastaseqimanip.h  -  description
                             -------------------
    begin                : Thu Jul 10 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_FASTASEQIMANIP_H
#define C_FASTASEQIMANIP_H

#include "iomanip_aa.h"
#include "c_seqlstimanip.h"

using namespace N_AminoAcid;

class C_FastaSeqIManip : public C_StreamManip <istream>
{
public:
    template <class seq_t>
    istream & operator >> (seq_t & Sequence) const;
};

const C_FastaSeqIManip ifastaseq = C_FastaSeqIManip ();

const C_SeqLstIManip <C_FastaSeqIManip> ifastaseqs = C_SeqLstIManip <C_FastaSeqIManip> ();

inline const C_FastaSeqIManip & operator >> (istream & Stream, const C_FastaSeqIManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};


template <class seq_t> istream & C_FastaSeqIManip:: operator >> (seq_t & Sequence) const
{
    typedef typename seq_t::value_type seq_value_type;
    char c = '\0';

    s () >> ws;
    if (s ().peek () != '>' || ! s ().good ())
        s ().setstate (ios::failbit);
    else
    {
        s () >> c >> Sequence.name () >> horws >> getLine >> Sequence.comments () >> ws;
        if (! s ().good ())
            s ().setstate (ios::failbit | ios::badbit);
        while (s ().good ())
        {
	    if (s ().peek () == ';')
                s () >> line >> ws;
            else if (s ().peek () == '/')
            {
                s ().get ();
                if (s ().get () != '/')
                    s ().setstate (ios::failbit | ios::badbit);
                else
                    break;
            }
            else if (s ().peek () == '>'){
		break;
	    }
            else
            {
                seq_value_type Val;
                s () >> aa1l >> Val >> ws;
                
		if (s ().fail ())
                    s ().setstate (ios::badbit);
                else
                    Sequence.push_back (Val);	
            }
        }
    }

    return s ();
};


#endif
