/***************************************************************************
                          c_fastaseqomanip.h  -  description
                             -------------------
    begin                : Thu Jul 10 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_FASTASEQOMANIP_H
#define C_FASTASEQOMANIP_H

#include "iomanip_aa.h"
#include "c_seqlstomanip.h"

using namespace N_AminoAcid;

class C_FastaSeqOManip : public C_StreamManip <ostream>
{
public:
    C_FastaSeqOManip (size_t SeqWidth_n = 50)
            : m_SeqWidth_n (SeqWidth_n)
    {}
    ;

    C_FastaSeqOManip operator () (size_t SeqWidth_n) const
    {
        return C_FastaSeqOManip (SeqWidth_n);
    };

    template <class seq_t>
    ostream & operator << (const seq_t & Sequence) const
    {
        if (! s ().good ())
        {
            s ().clear (ios::failbit | s ().rdstate ());
            return s ();
        }

        typedef typename seq_t::const_iterator iterator;

        s () << '>' << Sequence.name () << "    " << Sequence.comments () << endl;

        iterator Begin = Sequence.begin ();
        while (Begin < Sequence.end ())
        {
            for (iterator i = Begin; i < Sequence.end () && i < (Begin + m_SeqWidth_n); i ++)
                s () << aa1l << *i;

            s () << endl;
            Begin += m_SeqWidth_n;
        }
        return s () << endl;
    };


private:
    size_t m_SeqWidth_n;
};

const C_FastaSeqOManip ofastaseq = C_FastaSeqOManip (50);

typedef C_SeqLstOManip <C_FastaSeqOManip> C_FastaSeqsOManip;
const C_FastaSeqsOManip ofastaseqs = C_FastaSeqsOManip ();

inline const C_FastaSeqOManip & operator << (ostream & Stream, const C_FastaSeqOManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};

#endif
