/***************************************************************************
                          c_filepathname.h  -  description
                             -------------------
    begin                : Fri May 23 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_FILEPATHNAME_H
#define C_FILEPATHNAME_H

/**
  *@author Cyril Deremble
  */


/***************************************************************************
 *                                                                         *
 *   Include files                                                         *
 *                                                                         *
 ***************************************************************************/

#include <string>

namespace N_Tools
{
using namespace std;

/***************************************************************************
 *                                                                         *
 *   Class declaration                                                     *
 *                                                                         *
 ***************************************************************************/

class C_FilePathName : public string
{
public:
    explicit C_FilePathName ()
    {}
    ;

    C_FilePathName (const string & str)
            : string (str)
    {}
    ;
    C_FilePathName (const string & str, size_t pos, size_t n = npos)
            : string (str, pos, n)
    {}
    ;
    C_FilePathName (const char* s, size_t n)
            : string (s, n)
    {}
    ;
    C_FilePathName (const char* s)
            : string (s)
    {}
    ;
    C_FilePathName (size_t n, char c)
            : string (n, c)
    {}
    ;
    C_FilePathName (const_iterator begin, const_iterator end)
            : string (begin, end)
    {}
    ;

    ~C_FilePathName ()
    {}
    ;

    string getPath () const;
    string getName () const;
    string getLastExtension () const;
    string getExtension () const;
    string getNameWithoutExtension () const;
    string getPathNameWithoutExtension () const;

    char getDelimiter () const;
};


};

#endif
