/***************************************************************************
                          c_foldfitseqiomanip.h  -  description
                             -------------------
    begin                : Mon Aug 4 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_FOLDFITIOMANIP_H
#define C_FOLDFITIOMANIP_H

#include "iomanip_aa.h"
#include "c_seqlstimanip.h"

class C_FoldFitSeqIManip : public C_StreamManip <istream>
{
public:
    C_FoldFitSeqIManip () : m_SeqNb (0)
    {}
    ;

    template <class seq_t>
    istream & operator >> (seq_t & Sequence) const
    {
        typedef typename seq_t::value_type seq_value_type;
        char c = '\0';

        s () >> ws;
        if (s ().peek () != '>' || ! s ().good ())
            s ().setstate (ios::failbit);
        else
        {
            streampos BeginSeqPos = s ().tellg ();
            s () >> c >> Sequence.name () >> horws >> getLine >> Sequence.comments () >> ws;
            while (s ().good ())
                if (s ().get () == '/')
                {
                    if (s ().get () == '/')
                        break;
                    else
                        s () >> line >> ws;
                }

            s () >> ws;
            if (! s ().good ())
                s ().setstate (ios::failbit | ios::badbit);
            else
            {
                s () >> noskipws;
                while (s ().good ())
                {
                    for (size_t i = 0; i < m_SeqNb; i ++)
                        s ().get ();

                    seq_value_type Val;
                    s () >> aa1l >> Val >> line;
                    if (s ().fail ())
                        s ().setstate (ios::badbit);
                    else
                        Sequence.push_back (Val);

                    if (isWhiteSpace (s ().peek ()))
                        break;
                }

                s ().clear ();
                s ().seekg (BeginSeqPos);
                s () >> line >> horws;
                if (isWhiteSpace (s ().peek ()))
                {
                    s ().seekg (0, ios::end);
                    m_SeqNb = 0;
                }
                else
                    m_SeqNb ++;
            }
        }
        return s ();
    };

    void reset () const
    {
        m_SeqNb = 0;
    };

private:
    mutable size_t m_SeqNb;
};


const C_FoldFitSeqIManip ifoldfitseq = C_FoldFitSeqIManip ();
const C_SeqLstIManip <C_FoldFitSeqIManip> ifoldfitseqs = C_SeqLstIManip <C_FoldFitSeqIManip> ();

inline const C_FoldFitSeqIManip & operator >> (istream & Stream, const C_FoldFitSeqIManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};


class C_FoldFitSeqsOManip : public C_StreamManip <ostream>
{
public:
    template <class seqLst_t>
    ostream & operator << (const seqLst_t & Sequences_lst) const
    {
        typedef typename seqLst_t::const_iterator iterator;

        if (! Sequences_lst.empty ())
        {
            for (iterator i = Sequences_lst.begin (); i != Sequences_lst.end (); i ++)
                s () << '>' << i->name () << "    " << i->comments () << endl;

            s () << endl << "//" << endl;
            for (size_t i = 0; i < Sequences_lst.begin ()->size (); i ++)
            {
                for (iterator j = Sequences_lst.begin (); j != Sequences_lst.end (); j ++)
                    s () << aa1l << j->at (i);

                s () << endl;
            }
        }
        return s ();
    };
};


const C_FoldFitSeqsOManip ofoldfitseqs = C_FoldFitSeqsOManip ();

inline const C_FoldFitSeqsOManip & operator << (ostream & Stream, const C_FoldFitSeqsOManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};


#endif

