/***************************************************************************
                          c_hca.cpp  -  description
                             -------------------
    begin                : Mon Jul 7 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_hca.h"

C_HCA analyseClusters = C_HCA ();

C_HCA::
C_HCA ()
{
    m_Neighbours_vct.push_back (1);
    m_Neighbours_vct.push_back (2);
    m_Neighbours_vct.push_back (3);
    m_Neighbours_vct.push_back (4);
}

void
C_HCA::
operator () (seq_iterator Begin, seq_iterator End)
{
    for (hydr_iterator i (Begin, Begin, End); i != End; i ++)
    {
        cluster_t Cluster_i (i);

        for (neighbour_iterator k = m_Neighbours_vct.begin (); k != m_Neighbours_vct.end (); k ++)
        {
            aa_iterator j, Begin = i;

            for (j = Begin; j < Begin + *k; j ++)
            {
                if (j == End)
                    break;
                if (isClusterBreaker (*j))
                    break;
            }

            if (j == End)
                break;
            if (isClusterBreaker (*j))
                break;

            if (isHydrophobic (*j))
            {
                Cluster_i.add_safe (cluster_t::iterator (j));
            }
        }
    }
}

