/***************************************************************************
                          c_hca.h  -  description
                             -------------------
    begin                : Mon Jul 7 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_HCA_H
#define C_HCA_H

#include "c_analysedseq.h"


/**
  *@author Cyril Deremble
  */

class C_HCA
{
public:
    typedef C_AnalysedSeq::iterator seq_iterator;
    typedef vector <size_t> neighbours_t;
    
    C_HCA ();
    C_HCA (const vector <size_t> & Neighbours_vct) : m_Neighbours_vct (Neighbours_vct)
    {}
    ;

    ~C_HCA ()
    {}
    ;

    void operator () (seq_iterator Begin, seq_iterator End);
    void operator () (C_AnalysedSeq & Sequence)
    {
        operator () (Sequence.begin (), Sequence.end ());
    };

    neighbours_t & neighbours ()
    {
        return m_Neighbours_vct;
    };
    const neighbours_t & neighbours () const
    {
        return m_Neighbours_vct;
    };
    
private:
    neighbours_t m_Neighbours_vct;
    
    typedef C_AnalysedSeq::const_iterator seq_const_iterator;
    typedef C_AnalysedSeq::value_type seq_value_type;
    typedef C_AnalysedSeq::cluster_t cluster_t;
    typedef cluster_t::iterator clust_iterator;
    typedef clust_iterator::base_class_t aa_iterator;
    typedef C_TestIterator <S_IsHydrophobic, seq_value_type, seq_iterator> hydr_iterator;
    typedef neighbours_t::iterator neighbour_iterator;
};

extern C_HCA analyseClusters;


#endif
