/***************************************************************************
                          c_hcaparametersiomanip.cpp  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_hcaparametersiomanip.h"


C_XMLTag &
C_HCAParametersIOManip::
operator >> (C_HCA & AnalyseClusters) const
{
    is () >> ws;
    if (is ().name != "hca-parameters")
        is ().setstate (ios::failbit);
    else
        while (is ().good ())
        {
            C_XMLTag ParamTag;
            is () >> ParamTag >> ws;
            ParamTag >> ws;

            if (ParamTag.name == "cluster-neighbours")
            {
                AnalyseClusters.neighbours ().clear ();
                while (ParamTag.good ())
                {
                    C_XMLTag NeighbourTag;
                    size_t n;
                    ParamTag >> NeighbourTag >> ws;
                    if (NeighbourTag.name != "neighbour")
                        ParamTag.setstate (ios::failbit);
                    else
                    {
                        NeighbourTag >> n;
                        if (! NeighbourTag.fail ())
                            AnalyseClusters.neighbours ().push_back (n);
                        else
                            ParamTag.clear (ios::failbit);
                    }
                }
            }
            else
            {
                is ().setstate (ios::failbit);
            }

            if (ParamTag.fail ())
                is ().setstate (ios::failbit);
        }
    return is ();
};

ostream &
C_HCAParametersIOManip::
operator << (const C_HCA & AnalyseClusters) const
{
    os () << xml_begt ("hca-parameters") << endl

    << xml_begt ("cluster-neighbours") << endl;

    C_HCA::neighbours_t Neighbours = AnalyseClusters.neighbours ();
    for (C_HCA::neighbours_t::const_iterator i = Neighbours.begin ();
            i != Neighbours.end (); i ++)
        os () << xml_begt ("neighbour") << *i << xml_endt ("neighbour") << endl;

    os () << xml_endt ("cluster-neighbours") << endl

    << xml_endt ("hca-parameters") << endl;

    return os ();
};

