/***************************************************************************
                          c_iteratorbase.h  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_ITERATORBASE
#define C_ITERATORBASE

namespace N_Tools
{

template<typename T>
struct C_IteratorBase
{
    typedef typename T::value_type value_type;
    typedef typename T::pointer pointer_type;
    typedef typename T::reference reference_type;

    typedef pointer_type pointer;
    typedef reference_type reference;
};

template <typename T>
struct C_IteratorBase <T *>
{
    typedef T value_type;
    typedef T * pointer_type;
    typedef T & reference_type;

    typedef pointer_type pointer;
    typedef reference_type reference;
};

template <typename T>
struct C_IteratorBase <const T *>
{
    typedef T value_type;
    typedef const T * pointer_type;
    typedef const T & reference_type;

    typedef pointer_type pointer;
    typedef reference_type reference;
};

template <typename T>
struct C_IteratorBase <const T **>
{
    typedef T* value_type;
    typedef const value_type * pointer_type;
    typedef const value_type & reference_type;

    typedef pointer_type pointer;
    typedef reference_type reference;
};

};

#endif
