/***************************************************************************
                          c_parameterfile.cpp  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "c_parameterfile.h"


void
C_ParameterFile::
readParameters ()
{
    C_XMLTag ParamsTag;
    (*this) >> ParamsTag;
    if (ParamsTag.name != "hcaal-parameters")
        setstate (failbit);
    else
    {
        ParamsTag >> ws;
        while (ParamsTag.good ())
        {
            C_XMLTag ParamTag;
            ParamsTag >> ParamTag >> ws;
            if (ParamTag.name == "align-parameters")
                ParamTag >> xml_alignparams >> clustAlign;
            else if (ParamTag.name == "hca-parameters")
                ParamTag >> xml_hcaparams >> analyseClusters;
            else if (ParamTag.name == "aa-properties")
                ParamTag >> xml_aapropparams >> g_AAProperties;
            else if (ParamTag.name == "display-parameters")
                ParamTag >> xml_displayparams >> g_DisplayParameters;
            else if (ParamTag.name == "aa-codes")
                ParamTag >> xml_aacodes >> g_AACodes;
            else
                setstate (failbit);

            if (ParamTag.fail ())
                setstate (failbit);
        }

        if (ParamsTag.fail ())
            setstate (failbit);
    }
};

void
C_ParameterFile::
writeParameters ()
{
    (*this) << m_Header
    << xml_begt ("hcaal-parameters") << endl
    << xml_alignparams << clustAlign
    << xml_hcaparams << analyseClusters
    << xml_aapropparams << g_AAProperties
    << xml_displayparams << g_DisplayParameters
    << xml_aacodes << g_AACodes
    << xml_endt ("hcaal-parameters") << endl;
};

bool
C_ParameterFile::
isParameterFile ()
{
    string Buffer_str;

    clear ();
    seekg (0, beg);

    if (get () != '<') 
        return false;

    while (good ())
        if (get () == '<' && peek () != '?' && peek () != '!')
            break;

    (*this) >> word >> Buffer_str;
    clear ();
    seekg (0, beg);

    return (Buffer_str == "hcaal-parameters");
};
