/***************************************************************************
                          c_parameterfile.h  -  description
                             -------------------
    begin                : Fri Aug 1 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_PARAMETERFILE_H
#define C_PARAMETERFILE_H

#include <fstream>
#include "c_aapropertiesiomanip.h"
#include "c_hcaparametersiomanip.h"
#include "c_alignparametersiomanip.h"
#include "c_displayparameters.h"
#include "c_aacodesiomanip.h"

/**
  *@author Cyril Deremble
  */

class C_ParameterFile : public fstream
{
public:
    C_ParameterFile ()
    {
        m_Header.DOCTYPE_str = "hcaal-parameters";
    };
    C_ParameterFile (const string & FileName_str, openmode OpenMode)
            : fstream (FileName_str.c_str (), OpenMode)
    {
        m_Header.DOCTYPE_str = "hcaal-parameters";
        m_Header.XSLStylesheet_str = "http://www.ihes.fr/GENOMIQUE/Hcaal/Sources/hcaal_parameters_xml2html.xsl";
    };

    void open (const string & FileName_str, openmode OpenMode)
    {
        fstream::open (FileName_str.c_str (), OpenMode);
    };

    void readParameters ();

    void writeParameters ();

    bool isParameterFile ();

private:
    S_XMLHeader m_Header;
};

#endif
