/***************************************************************************
                          c_scoreconservedres.h  -  description
                             -------------------
    begin                : Tue Aug 5 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_SCORECONSERVEDRES_H
#define C_SCORECONSERVEDRES_H

#include "_aminoacids.h"

using namespace N_AminoAcid;

class C_ScoreConservedRes
{
public:
    template <class seqLst_t>
    void operator () (seqLst_t & Sequences_lst) const
    {
        typedef typename seqLst_t::iterator iterator;
        typedef map <E_AminoAcid, size_t> res_score_map_t;
        typedef res_score_map_t::iterator map_iterator;

        res_score_map_t ResScoreMap;
        float Tot;

        if (Sequences_lst.areAligned () && ! Sequences_lst.empty ())
        {
            for (size_t i = 0; i < Sequences_lst.begin ()->size (); i ++)
            {
                ResScoreMap.clear ();
                Tot = 0;
                for (iterator j = Sequences_lst.begin (); j != Sequences_lst.end (); j ++)
                {
                    ++ ResScoreMap [j->at (i)];
                    ++ Tot;
                }
                for (map_iterator k = ResScoreMap.begin (); k != ResScoreMap.end (); k ++)
                {
                    k->second = static_cast <size_t> (10*k->second/Tot);
                    if (k->second > 9)
                        k->second = 9;
                }
                for (iterator j = Sequences_lst.begin (); j != Sequences_lst.end (); j ++)
                {
                    E_AminoAcid AA = j->at (i);
                    if (isAA (AA))
                        j->at (i).ConservedScore = ResScoreMap [AA];
                    else
                        j->at (i).ConservedScore = 0;
                }
            }
        }
    };
};

const C_ScoreConservedRes scoreConservedRes = C_ScoreConservedRes ();

#endif
