/***************************************************************************
                          c_seqlstimanip.h  -  description
                             -------------------
    begin                : Wed Jul 9 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_SEQLSTIMANIP_H
#define C_SEQLSTIMANIP_H

#include "iomanip_ext.h"

using namespace N_Tools;

template <class seqimanip_t>
		class C_SeqLstIManip : public C_StreamManip <istream>
{
	public:
		C_SeqLstIManip (const seqimanip_t & SeqIManip = seqimanip_t ())
	: m_seq_format (SeqIManip)
		{}
		
		template <class seqLst_t>
				istream & operator >> (seqLst_t & Sequences_lst) const
		{
			typedef typename seqLst_t::value_type seqLstValueType_t;
			while (s ().good ())
			{
				Sequences_lst.push_back (seqLstValueType_t ());
				s () >> m_seq_format >> Sequences_lst.back () >> ws;
			}
			if (s ().fail ())
				Sequences_lst.pop_back ();
			return s ();
		}
		
		seqimanip_t m_seq_format;
};

template <class seqimanip_t>
		inline const C_SeqLstIManip <seqimanip_t> & operator >> (istream & Stream, const C_SeqLstIManip <seqimanip_t> & Manip)
{
	Manip.setStream (Stream);
	return Manip;
}



#endif
