/***************************************************************************
                          c_seqlstomanip.h  -  description
                             -------------------
    begin                : Tue Jul 29 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_SEQLSTOMANIP_H
#define C_SEQLSTOMANIP_H

#include "iomanip_ext.h"

using namespace N_Tools;

template <class seqomanip_t>
class C_SeqLstOManip : public C_StreamManip <ostream>
{
public:
    C_SeqLstOManip (const seqomanip_t & SeqOManip = seqomanip_t ())
            : m_seq_format (SeqOManip)
    {}
    ;

    template <class seqLst_t>
    ostream & operator << (seqLst_t & Sequences_lst) const
    {
        typedef typename seqLst_t::const_iterator iterator;
        for (iterator i = Sequences_lst.begin (); i != Sequences_lst.end (); i ++)
            s () << m_seq_format << *i;
        return s ();
    };

    seqomanip_t m_seq_format;
};

template <class seqomanip_t>
inline const C_SeqLstOManip <seqomanip_t> & operator << (ostream & Stream, const C_SeqLstOManip <seqomanip_t> & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};

#endif
