/***************************************************************************
                          c_treeimanip.h  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_TREEIMANIP_H
#define C_TREEIMANIP_H


/**
  *@author Cyril Deremble
  */
  
#include <config.h>
#include "iomanip_ext.h"

class C_TreeIManip : public C_StreamManip <istream>
{
public:

    template <class treenode_t>
    istream & operator >> (treenode_t & TreeNode) const
    {
        typedef typename treenode_t::child_type treenode_child_type_t;
        char c;
        s () >> c >> ws;
        if (! s ().good () || c != '(')
        {
            s ().clear (ios::failbit | s ().rdstate ());
        }
        else
        {
            while (s ().good ())
            {
                if (s ().peek () == ',')
                {
                    s () >> c >> ws;
                }
                else if (s ().peek () == '(')
                {
                    TreeNode.childs ().push_back (treenode_child_type_t ());
                    operator >> (TreeNode.childs ().back ());
                    s () >> c >> TreeNode.childs ().back ().dist () >> ws;
                    if (c != ':')
                        s ().clear (ios::failbit | s ().rdstate ());
                }
                else if (s ().peek () == ')')
                {
                    s () >> c >> ws;
                    if (s ().good ())
                        if (s ().peek () == ';')
                            s ().get ();
                    break;
                }
                else
                {
                    TreeNode.childs ().push_back (treenode_child_type_t ());
                    s () >> word >> TreeNode.childs ().back ().value () >> c >> TreeNode.childs ().back ().dist () >> ws;
                    if (c != ':')
                        s ().clear (ios::failbit | s ().rdstate ());
                }
            }
        }
    };
};

const C_TreeIManip itree = C_TreeIManip ();

inline const C_TreeIManip & operator >> (istream & Stream, const C_TreeIManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};

#endif
