/***************************************************************************
                          c_treeomanip.h  -  description
                             -------------------
    begin                : Wed Jan 21 2004
    copyright            : (C) 2004 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef C_TREEOMANIP_H
#define C_TREEOMANIP_H

#include <config.h>
#include "iomanip_ext.h"

using namespace N_Tools;

/**
  *@author Cyril Deremble
  */

class C_TreeOManip : public C_StreamManip <ostream>
{
public:
    template <class treenode_t>
    ostream & operator << (treenode_t & TreeNode) const
    {
        if (TreeNode.isLeaf ())
        {
            s () << TreeNode.value ();
        }
        else
        {
            typedef typename treenode_t::childs_type::const_iterator iterator;

            s () << "(\n";
    
            for (iterator i = TreeNode.childs ().begin (); i != TreeNode.childs ().end (); i ++)
            {
                if (i != TreeNode.childs ().begin ())
                {
                    s () << ",\n";
                }
                operator << (*i);
                s () << ':' << i->dist ();
            }
    
            s () << "\n)";
            if (TreeNode.isRoot ())
                s () << ';';
        }
        return s ();
    };
};

const C_TreeOManip otree = C_TreeOManip ();

inline const C_TreeOManip & operator << (ostream & Stream, const C_TreeOManip & Manip)
{
    Manip.setStream (Stream);
    return Manip;
};

#endif
