/***************************************************************************
                          s_are.h  -  description
                             -------------------
    begin                : Tue Jul 8 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef S_ARE_H
#define S_ARE_H

#include <functional>

namespace N_Tools
{

/**
  *@author Cyril Deremble
  */

template <class unaryTest_t>
struct S_Are
{
    unaryTest_t test;

    template <class iterator>
    bool operator () (const iterator & Begin_it,
                      const iterator & End_it,
                      iterator & Bad_it) const
    {
        for (iterator i = Begin_it; i != End_it; i ++)
            if (! test (*i))
            {
                Bad_it = i;
                return false;
            }
        return true;
    };

    template <class iterator>
    bool operator () (const iterator & Begin_it,
                      const iterator & End_it) const
    {
        for (iterator i = Begin_it; i != End_it; i ++)
            if (! test (*i))
                return false;
        return true;
    };
};

};

#endif
