/***************************************************************************
                          subsmats.h  -  description
                             -------------------
    begin                : Fri Jun 20 2003
    copyright            : (C) 2003 by Cyril Deremble
    email                : deremble@ihes.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUBSMATS_H
#define SUBSMATS_H

namespace N_AminoAcid
{


/***************************************************************************
 *                                                                         *
 *   Substitution matrices                                                 *
 *                                                                         *
 ***************************************************************************/

/** outside block matrix */
const short g_ohbm_p [AMINO_ACID_COUNT*AMINO_ACID_COUNT] =
    {
  // A,  R,  N,  D,  B,  C,  Q,  E,  Z,  G,  H,  I,  L,  K,  M,  F,  P,  U,  S,  T,  W,  Y,  V,  X,  *,  .,  ?,  //
	6,   1,   1,   1,   1,   3,   1,   1,   1,   2,   1,  -8,  -8,   1,  -7,  -7,   4,  -13,   3,   2,  -5,  -8,  -6,  -13,  -13,  -13,  -13,//A
	1,  8,  2,  1,  1, -2,  3,  2,  2,  0,  2, -9, -8,  4, -7, -6,  2, -13,  1,  1, -7, -5, -8, -13, -13, -13, -13,//R
	1,  2,  9,  4,  4,  0,  3,  1,  1,  3,  4, -10, -9,  2, -9, -5,  3, -13,  4,  3, -6, -4, -8, -13, -13, -13, -13,//N
	1,  1,  4,  9,  9, -1,  3,  4,  4,  1,  1, -10, -9,  1, -9, -8,  3, -13,  2,  2, -6, -6, -9, -13, -13, -13, -13,//D
	1,  1,  4,  9,  9, -1,  3,  4,  4,  1,  1, -10, -9,  1, -9, -8,  3, -13,  2,  2, -6, -6, -9, -13, -13, -13, -13,//B
	3, -2,  0, -1, -1, 16,  0, -2, -2,  0,  1, -9, -7, -2, -7, -7,  2, -13,  2,  1, -9, -8, -9, -13, -13, -13, -13,//C
	1,  3,  3,  3,  3,  0,  6,  4,  4,  1,  3, -7, -7,  3, -5, -7,  3, -13,  2,  2, -4, -4, -7, -13, -13, -13, -13,//Q
	1,  2,  1,  4,  4, -2,  4,  7,  7,  1,  2, -11, -9,  3, -7, -9,  4, -13,  2,  2, -7, -8, -8, -13, -13, -13, -13,//E
	1,  2,  1,  4,  4, -2,  4,  7,  7,  1,  2, -11, -9,  3, -7, -9,  4, -13,  2,  2, -7, -8, -8, -13, -13, -13, -13,//Z
	2,  0,  3,  1,  1,  0,  1,  1,  1, 10,  1, -11, -8,  1, -6, -7,  3, -13,  3,  1, -6, -5, -8, -13, -13, -13, -13,//G
	1,  2,  4,  1,  1,  1,  3,  2,  2,  1, 13, -8, -8,  1, -6, -5,  2, -13,  2,  1, -4, -4, -6, -13, -13, -13, -13,//H
	-8, -9, -10, -10, -10, -9, -7, -11, -11, -11, -8, -4, -7, -9, -8, -8, -4, -13, -10, -5, -9, -8, -6, -13, -13, -13, -13,//I
	-8, -8, -9, -9, -9, -7, -7, -9, -9, -8, -8, -7, -3, -8, -4, -7, -4, -13, -8, -6, -10, -8, -7, -13, -13, -13, -13,//L
	1,  4,  2,  1,  1, -2,  3,  3,  3,  1,  1, -9, -8,  6, -8, -9,  4, -13,  2,  2, -6, -7, -8, -13, -13, -13, -13,//K
	-7, -7, -9, -9, -9, -7, -5, -7, -7, -6, -6, -8, -4, -8, -1, -6, -4, -13, -8, -3, -4, -7, -9, -13, -13, -13, -13,//M
	-7, -6, -5, -8, -8, -7, -7, -9, -9, -7, -5, -8, -7, -9, -6,  1, -4, -13, -6, -5, -4, -3, -10, -13, -13, -13, -13,//F
	4,  2,  3,  3,  3,  2,  3,  4,  4,  3,  2, -4, -4,  4, -4, -4, 15, -13,  4,  3, -2, -4, -2, -13, -13, -13, -13,//P
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//U
	3,  1,  4,  2,  2,  2,  2,  2,  2,  3,  2, -10, -8,  2, -8, -6,  4, -13,  6,  4, -4, -6, -7, -13, -13, -13, -13,//S
	2,  1,  3,  2,  2,  1,  2,  2,  2,  1,  1, -5, -6,  2, -3, -5,  3, -13,  4,  7, -4, -5, -5, -13, -13, -13, -13,//T
	-5, -7, -6, -6, -6, -9, -4, -7, -7, -6, -4, -9, -10, -6, -4, -4, -2, -13, -4, -4,  3, -3, -9, -13, -13, -13, -13,//W
	-8, -5, -4, -6, -6, -8, -4, -8, -8, -5, -4, -8, -8, -7, -7, -3, -4, -13, -6, -5, -3,  3, -11, -13, -13, -13, -13,//Y
	-6, -8, -8, -9, -9, -9, -7, -8, -8, -8, -6, -6, -7, -8, -9, -10, -2, -13, -7, -5, -9, -11, -6, -13, -13, -13, -13,//V
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//X
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//*
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, //.
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, //?
    };

/** inside block matrix */
const short g_ihbm_p [AMINO_ACID_COUNT*AMINO_ACID_COUNT] =
    {
        // A,  R,  N,  D,  B,  C,  Q,  E,  Z,  G,  H,  I,  L,  K,  M,  F,  P,  U,  S,  T,  W,  Y,  V,  X,  *,  .,  ?,  //
	3, -1, -2, -3, -3,  0, -1, -1, -1, -1, -2,  0,  0, -1,  1,  0, -5, -13,  0, -1,  0, -1,  1, -13, -13, -13, -13,//A
	-1,  6,  0, -1, -1, -4,  1,  0,  0, -3,  0, -2, -1,  2,  0, -2, -4, -13,  0, -1, -1,  0, -2, -13, -13, -13, -13,//R
	-2,  0,  5,  1,  1, -3,  0,  0,  0, -1,  0, -3, -2,  0, -1, -2, -3, -13,  0,  0, -2, -1, -2, -13, -13, -13, -13,//N
	-3, -1,  1,  6,  6, -5,  0,  1,  1, -1, -2, -4, -3,  0, -3, -3, -3, -13,  0, -1, -1, -1, -3, -13, -13, -13, -13,//D
	-3, -1,  1,  6,  6, -5,  0,  1,  1, -1, -2, -4, -3,  0, -3, -3, -3, -13,  0, -1, -1, -1, -3, -13, -13, -13, -13,//B
	0, -4, -3, -5, -5, 10, -3, -4, -4, -2, -4,  1,  1, -4,  0,  0, -8, -13, -1, -2, -1,  0,  2, -13, -13, -13, -13,//C
	-1,  1,  0,  0,  0, -3,  4,  2,  2, -2,  0, -2, -1,  1,  0, -1, -4, -13,  0, -1,  0,  0, -1, -13, -13, -13, -13,//Q
	-1,  0,  0,  1,  1, -4,  2,  4,  4, -3, -1, -3, -3,  1, -2, -3, -4, -13,  0,  0, -1, -1, -2, -13, -13, -13, -13,//E
	-1,  0,  0,  1,  1, -4,  2,  4,  4, -3, -1, -3, -3,  1, -2, -3, -4, -13,  0,  0, -1, -1, -2, -13, -13, -13, -13,//Z
	-1, -3, -1, -1, -1, -2, -2, -3, -3,  6, -2, -3, -3, -2, -2, -3, -5, -13,  0, -2, -3, -2, -2, -13, -13, -13, -13,//G
	-2,  0,  0, -2, -2, -4,  0, -1, -1, -2,  7, -2, -1,  0, -1,  0, -4, -13, -1, -1,  1,  1, -2, -13, -13, -13, -13,//H
	0, -2, -3, -4, -4,  1, -2, -3, -3, -3, -2,  6,  4, -2,  3,  2, -2, -13, -2,  0,  0,  1,  5, -13, -13, -13, -13,//I
	0, -1, -2, -3, -3,  1, -1, -3, -3, -3, -1,  4,  6, -2,  4,  3, -2, -13, -1,  0,  1,  1,  3, -13, -13, -13, -13,//L
	-1,  2,  0,  0,  0, -4,  1,  1,  1, -2,  0, -2, -2,  4,  0, -2, -3, -13,  0, -1, -2, -1, -2, -13, -13, -13, -13,//K
	1,  0, -1, -3, -3,  0,  0, -2, -2, -2, -1,  3,  4,  0,  7,  2, -2, -13,  0,  0,  1,  2,  2, -13, -13, -13, -13,//M
	0, -2, -2, -3, -3,  0, -1, -3, -3, -3,  0,  2,  3, -2,  2,  8, -3, -13, -2, -1,  4,  5,  2, -13, -13, -13, -13,//F
	-5, -4, -3, -3, -3, -8, -4, -4, -4, -5, -4, -2, -2, -3, -2, -3, -13, -13, -3, -4, -2, -2, -2, -13, -13, -13, -13,//P
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//U
	0,  0,  0,  0,  0, -1,  0,  0,  0,  0, -1, -2, -1,  0,  0, -2, -3, -13,  3,  1, -1, -1, -1, -13, -13, -13, -13,//S
	-1, -1,  0, -1, -1, -2, -1,  0,  0, -2, -1,  0,  0, -1,  0, -1, -4, -13,  1,  3, -1,  0,  1, -13, -13, -13, -13,//T
	0, -1, -2, -1, -1, -1,  0, -1, -1, -3,  1,  0,  1, -2,  1,  4, -2, -13, -1, -1, 13,  5,  0, -13, -13, -13, -13,//W
	-1,  0, -1, -1, -1,  0,  0, -1, -1, -2,  1,  1,  1, -1,  2,  5, -2, -13, -1,  0,  5,  8,  0, -13, -13, -13, -13,//Y
	1, -2, -2, -3, -3,  2, -1, -2, -2, -2, -2,  5,  3, -2,  2,  2, -2, -13, -1,  1,  0,  0,  6, -13, -13, -13, -13,//V
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//X
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13,//*
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, //.
	-13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, -13, //?
    };

};

#endif
